rm -f *.err
rm -rf temp-scripts

mkdir temp-scripts
mkdir /nobackup/durtw/compare-to-other-solvers


for nodes in 1 2 4 6 8 12 16
do
 for dim in Dim2 Dim3
 do
  for dt in 0.01 0.001 0.0001
  do
   for ppc in 10 100 1000
   do
    for particles in 1000000 10000000
    do
     destscriptname=rapidt"_"$nodes"_"$dim"_"$dt"_"$ppc"_"$particles
     sed "s/NODES/$nodes/g"           Experiment_rapidt.csh    > temp-scripts/tmp0.script
     sed "s/DIM/$dim/g"               temp-scripts/tmp0.script > temp-scripts/tmp1.script
     sed "s/DT/$dt/g"                 temp-scripts/tmp1.script > temp-scripts/tmp0.script
     sed "s/PPC/$ppc/g"               temp-scripts/tmp0.script > temp-scripts/tmp1.script
     sed "s/PARTICLES/$particles/g"   temp-scripts/tmp1.script > temp-scripts/$destscriptname
      
     qsub temp-scripts/$destscriptname


     for variant in "pit" "pidt" "sieve-forward" "sieve-backward" "sieve-drop" "sfc-cuts-forward" "sfc-cuts-backward" "sfc-cuts-drop"  "md"
     do
      destscriptname=$variant"_"$nodes"_"$dim"_"$dt"_"$ppc"_"$particles
      sed "s/NODES/$nodes/g"           Experiment.csh           > temp-scripts/tmp0.script
      sed "s/DIM/$dim/g"               temp-scripts/tmp0.script > temp-scripts/tmp1.script
      sed "s/DT/$dt/g"                 temp-scripts/tmp1.script > temp-scripts/tmp0.script
      sed "s/PPC/$ppc/g"               temp-scripts/tmp0.script > temp-scripts/tmp1.script
      sed "s/PARTICLES/$particles/g"   temp-scripts/tmp1.script > temp-scripts/tmp0.script
      sed "s/VARIANT/$variant/g"       temp-scripts/tmp0.script > temp-scripts/$destscriptname
      
      qsub temp-scripts/$destscriptname
     done

    done
   done  
  done
 done
done

qstat
