#
# argument is the prefix such as supermuc
#
#
import sys
import os
import pylab

from helpers import *




dimensions = [ 2, 3 ]
ppcs       = [ 100000, 10000, 1000, 100 ]
particless = [ 10000000, 100000000, 1000000000 ]
flopss     = [ 0, 128, 256, 1024, 4096 ]


MaxTimeSteps = 50
#AlphaValue   = 0.02
AlphaValue   = 0.9
   

def getMeasurements(dim,particles,ppc,flops):
  inputFileName = "throughput-" + sys.argv[1] + "_mpi_" + str(dim) + "d_" + str(particles) + "_particles.table"
  result = []
  startColumn   = 2
  if flops==0:
    startColumn = startColumn + 0
  if flops==128:
    startColumn = startColumn + 1
  if flops==256:
    startColumn = startColumn + 2
  if flops==1024:
    startColumn = startColumn + 3
  if flops==4096:
    startColumn = startColumn + 4
  if ppc==100000:
    startColumn = startColumn + 0
  if ppc==10000:
    startColumn = startColumn + 5
  if ppc==1000:
    startColumn = startColumn + 10
  if ppc==100:
    startColumn = startColumn + 15
  result.append( readColumnFromTable( inputFileName, 1 ) )
  result.append( readColumnFromTable( inputFileName, startColumn ) )
  return result


def setSpecificPlotSettings():
  pylab.clf()
  pylab.xlabel('cores')
  pylab.ylabel('#particles/s')
  pylab.loglog( basex=2, basey=2 )
  #pylab.loglog( basex=10, basey=2 )
  pylab.ylim([5e6,1.2e9])
  #pylab.ylim([1e6,1e9])
  pylab.yticks([ 1e7, 1e8, 1e9 ],[ "$10^7$", "$10^8$", "$10^9$" ])
  #pylab.yticks([ 1e6, 1e7, 1e8, 1e9 ],[ "$10^6$", "$10^7$", "$10^8$", "$10^9$" ])

  #pylab.xlim([1,2048])
  pylab.xlim([16,2048])
  pylab.xticks(
    [  16 ,  64,   256,   1024  ], 
    [ "16", "64", "256", "1024" ]
  )
  #pylab.xticks(
  #  [  1,   4,   16 ,  64,   256,   1024  ], 
  #  [ "1", "4", "16", "64", "256", "1024" ]
  #)

  pylab.plot( [1,2048], [1e6,2048*1e6], "-", color="#000000" )


summaryHTMLFile = open("summary-" + sys.argv[1] + ".html", "w" )


#
# Nummerierung
#  - particles (3 Varianten)
#  - ppc (4 Varianten)
#  - flops (5+1 Varianten)
#
symbols = [ 
  ":o",       ":o",       ":o",       ":o",       ":o",       "-o",  # 0:  1e7 particles, 100000 ppc, 0-x flops
  ":o",       ":o",       ":o",       ":o",       ":o",       "-o",  # 6:  1e7 particles, 10000 ppc, 0-x flops
  ":o",       ":o",       ":o",       ":o",       ":o",       "-o",  # 12: 1e7 particles, 1000 ppc, 0-x flops
  ":o",       ":o",       ":o",       ":o",       ":o",       "-o",  # 18: 1e7 particles, 100 ppc, 0-x flops

  ":^",       ":^",       ":^",       ":^",       ":^",       "-^",  # 24: 
  ":^",       ":^",       ":^",       ":^",       ":^",       "-^",
  ":^",       ":^",       ":^",       ":^",       ":^",       "-^",  # 36: 1e8 particles, 1000 ppc, 0-x flops
  ":^",       ":^",       ":^",       ":^",       ":^",       "-^",

  ":s",       ":s",       ":s",       ":s",       ":s",       "-s",  # 48
  ":s",       ":s",       ":s",       ":s",       ":s",       "-s",  # 54
  ":s",       ":s",       ":s",       ":s",       ":s",       "-s",  # 60: 1e9 particles, 1000 ppc, 0-x flops
  ":s",       ":s",       ":s",       ":s",       ":s",       "-s"
]
colours = [ 
  "#333333", "#888888", "#aaaaaa", "#cccccc", "#eeeeee", "#333333",
  "#ff0000", "#ff4444", "#ff7777", "#ffaaaa", "#ffdddd", "#ff0000",
  "#00ff00", "#44ff44", "#77ff77", "#aaffaa", "#ddffdd", "#00ff00",
  "#0000ff", "#4444ff", "#7777ff", "#aaaaff", "#ddddff", "#0000ff",
 
  "#333333", "#888888", "#aaaaaa", "#cccccc", "#eeeeee", "#333333",
  "#ff0000", "#ff4444", "#ff7777", "#ffaaaa", "#ffdddd", "#ff0000",
  "#00ff00", "#44ff44", "#77ff77", "#aaffaa", "#ddffdd", "#00ff00",
  "#0000ff", "#4444ff", "#7777ff", "#aaaaff", "#ddddff", "#0000ff",
 
  "#333333", "#888888", "#aaaaaa", "#cccccc", "#eeeeee", "#333333",
  "#ff0000", "#ff4444", "#ff7777", "#ffaaaa", "#ffdddd", "#ff0000",
  "#00ff00", "#44ff44", "#77ff77", "#aaffaa", "#ddffdd", "#00ff00",
  "#0000ff", "#4444ff", "#7777ff", "#aaaaff", "#ddddff", "#0000ff",
    ]
#colours = [ 
#  "#ff0000", "#ff3333", "#ff6666", "#ff9999", "#ffcccc", "#ff0000",
#  "#00ff00", "#33ff33", "#66ff66", "#99ff99", "#ccffcc", "#00ff00",
#  "#0000ff", "#3333ff", "#6666ff", "#9999ff", "#ccccff", "#0000ff",
#  "#333333", "#666666", "#888888", "#aaaaaa", "#dddddd", "#333333",
#
#  "#ff0000", "#ff3333", "#ff6666", "#ff9999", "#ffcccc", "#ff0000",
#  "#00ff00", "#33ff33", "#66ff66", "#99ff99", "#ccffcc", "#00ff00",
#  "#0000ff", "#3333ff", "#6666ff", "#9999ff", "#ccccff", "#0000ff",
#  "#333333", "#666666", "#888888", "#aaaaaa", "#dddddd", "#333333",#
#
#  "#ff0000", "#ff3333", "#ff6666", "#ff9999", "#ffcccc", "#ff0000",
#  "#00ff00", "#33ff33", "#66ff66", "#99ff99", "#ccffcc", "#00ff00",
#  "#0000ff", "#3333ff", "#6666ff", "#9999ff", "#ccccff", "#0000ff",
#  "#333333", "#666666", "#888888", "#aaaaaa", "#dddddd", "#333333",
#    ]

markersizes = [
  17, 17, 17, 17, 17, 17,
  14, 14, 14, 14, 14, 14,
  11, 11, 11, 11, 11, 11,
  9,   9,  9,  9,  9,  9,

  17, 17, 17, 17, 17, 17,
  14, 14, 14, 14, 14, 14,
  11, 11, 11, 11, 11, 11,
  9,   9,  9,  9,  9,  9,

  17, 17, 17, 17, 17, 17,
  14, 14, 14, 14, 14, 14,
  11, 11, 11, 11, 11, 11,
  9,   9,  9,  9,  9,  9,
]


def printPPC100And1000():
    for dim in dimensions:
      outputFileName = "throughput-" + sys.argv[1] + "-" + str(dim) + "d"
      print "create " + outputFileName + " for ppc=100 and ppc=1000"
    
      setSpecificPlotSettings()
    
      symbolAndColourCounter = 0
      for particles in particless:
        symbolAndColourCounter = symbolAndColourCounter + 6*2
        for ppc in [ 1000, 100 ]:    
          for flops in flopss:
            pylab.plot( getMeasurements(dim,particles,ppc,flops)[0], getMeasurements(dim,particles,ppc,flops)[1],  symbols[symbolAndColourCounter], color=colours[symbolAndColourCounter], markersize=markersizes[symbolAndColourCounter], markevery=1, alpha=AlphaValue )     
            symbolAndColourCounter = symbolAndColourCounter + 1
          symbolAndColourCounter = symbolAndColourCounter + 1
    
      setGeneralPlotSettings()
        
      pylab.title( toString(sys.argv[1]) + ", " + str(dim) + "d" )
    
      pylab.savefig( outputFileName + "-100-1000ppc.png" )
      pylab.savefig( outputFileName + "-100-1000ppc.pdf" )
      pylab.savefig( outputFileName + "-100-1000ppc.eps" )
      summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
  
  
  
def printPPC1000And10000():
    for dim in dimensions:
      outputFileName = "throughput-" + sys.argv[1] + "-" + str(dim) + "d"
      print "create " + outputFileName + " for ppc=1000 and ppc=10000"
    
      setSpecificPlotSettings()
    
      symbolAndColourCounter = 0
      for particles in particless:
        symbolAndColourCounter = symbolAndColourCounter + 6
        for ppc in [ 10000, 1000 ]:    
          for flops in flopss:
            pylab.plot( getMeasurements(dim,particles,ppc,flops)[0], getMeasurements(dim,particles,ppc,flops)[1],  symbols[symbolAndColourCounter], color=colours[symbolAndColourCounter], markersize=markersizes[symbolAndColourCounter], markevery=1, alpha=AlphaValue )     
            symbolAndColourCounter = symbolAndColourCounter + 1
          symbolAndColourCounter = symbolAndColourCounter + 1
        symbolAndColourCounter = symbolAndColourCounter + 6
    
      setGeneralPlotSettings()
        
      pylab.title( toString(sys.argv[1]) + ", " + str(dim) + "d" )
    
      pylab.savefig( outputFileName + "-1000-10000ppc.png" )
      pylab.savefig( outputFileName + "-1000-10000ppc.pdf" )
      pylab.savefig( outputFileName + "-1000-10000ppc.eps" )
      summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
         

def printAll():
    for dim in dimensions:
      outputFileName = "throughput-" + sys.argv[1] + "-" + str(dim) + "d"
      print "create " + outputFileName
    
      setSpecificPlotSettings()
    
      symbolAndColourCounter = 0
      for particles in particless:
        for ppc in ppcs:    
          for flops in flopss:
            pylab.plot( getMeasurements(dim,particles,ppc,flops)[0], getMeasurements(dim,particles,ppc,flops)[1],  symbols[symbolAndColourCounter], color=colours[symbolAndColourCounter], markersize=markersizes[symbolAndColourCounter], markevery=1, alpha=AlphaValue )     
            symbolAndColourCounter = symbolAndColourCounter + 1
          symbolAndColourCounter = symbolAndColourCounter + 1
    
      setGeneralPlotSettings()
        
      pylab.title( toString(sys.argv[1]) + ", " + str(dim) + "d" )
    
      pylab.savefig( outputFileName + ".png" )
      pylab.savefig( outputFileName + ".pdf" )
      pylab.savefig( outputFileName + ".eps" )
      summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
 

def print0Flops():
    for dim in dimensions:
      outputFileName = "throughput-" + sys.argv[1] + "-" + str(dim) + "d"
      print "create " + outputFileName + " for 0 flops"
    
      setSpecificPlotSettings()
    
      symbolAndColourCounter = 0
      for particles in particless:
        for ppc in ppcs:    
          pylab.plot( getMeasurements(dim,particles,ppc,flopss[0])[0], getMeasurements(dim,particles,ppc,flopss[0])[1], symbols[symbolAndColourCounter+5],  label="#particles=" + "%.1e" % particles, color=colours[symbolAndColourCounter], markersize=markersizes[symbolAndColourCounter], markevery=1, alpha=1.0        )
          symbolAndColourCounter = symbolAndColourCounter + 6
    
    
      pylab.plot( [1,2048], [1e6,2048*1e6], "-", label="linear", color="#000000" )
    
      setGeneralPlotSettings()
        
      pylab.title( toString(sys.argv[1]) + ", " + str(dim) + "d, no flops, different ppc" )
    
      pylab.legend(loc='upper left',framealpha=0.5)
      pylab.savefig( outputFileName + "-no-flops.png" )
      pylab.savefig( outputFileName + "-no-flops.pdf" )
      pylab.savefig( outputFileName + "-no-flops.eps" )
      summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
   
      pylab.legend().set_visible(False)
      pylab.savefig( outputFileName + "-no-flops-no-legend.png" )
      pylab.savefig( outputFileName + "-no-flops-no-legend.pdf" )
      pylab.savefig( outputFileName + "-no-flops-no-legend.eps" )
      summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
       
      setSpecificPlotSettings()

      pylab.plot([192*1,192*1],[5e6,2e9],"--",color="#000000")
      pylab.plot([192*2,192*2],[5e6,2e9],"--",color="#000000")
      pylab.plot([192*4,192*4],[5e6,2e9],"--",color="#000000")
      pylab.plot([192*8,192*8],[5e6,2e9],"--",color="#000000")

      symbolAndColourCounter = 0
      for particles in [ 10000000, 100000000 ]:
      #for particles in particless:
        symbolAndColourCounter = symbolAndColourCounter + 6
        for ppc in ppcs[1:]: 
          if particles==10000000:
            pylab.plot( getMeasurements(dim,particles,ppc,flopss[0])[0], getMeasurements(dim,particles,ppc,flopss[0])[1], symbols[symbolAndColourCounter+5], label="pcc=" + str(ppc), color=colours[symbolAndColourCounter], markersize=markersizes[symbolAndColourCounter], markevery=1, alpha=1.0        )
          else:
            pylab.plot( getMeasurements(dim,particles,ppc,flopss[0])[0], getMeasurements(dim,particles,ppc,flopss[0])[1], symbols[symbolAndColourCounter+5], color=colours[symbolAndColourCounter], markersize=markersizes[symbolAndColourCounter], markevery=1, alpha=1.0 )
          symbolAndColourCounter = symbolAndColourCounter + 6
    
      pylab.plot( [1,2048], [1e6,2048*1e6], "-", color="#000000" )

      setGeneralPlotSettings()
        
      pylab.title( toString(sys.argv[1]) + ", " + str(dim) + "d, no flops" )
    
      pylab.legend(loc='upper left',framealpha=0.5)
      pylab.savefig( outputFileName + "-no-flops-no-100000.png" )
      pylab.savefig( outputFileName + "-no-flops-no-100000.pdf" )
      pylab.savefig( outputFileName + "-no-flops-no-100000.eps" )
      summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
   
      pylab.legend().set_visible(False)
      pylab.savefig( outputFileName + "-no-flops-no-100000-no-legend.png" )
      pylab.savefig( outputFileName + "-no-flops-no-100000-no-legend.pdf" )
      pylab.savefig( outputFileName + "-no-flops-no-100000-no-legend.eps" )
      summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
       

def printPPCs():
    for dim in dimensions:
      ppcCounter = 0
      for ppc in ppcs:    
        outputFileName = "throughput-" + sys.argv[1] + "-" + str(dim) + "d_" + str(ppc) + "-ppc"
        print "create " + outputFileName
    
        setSpecificPlotSettings()
    
        symbolAndColourCounter = ppcCounter*6
        for particles in particless:
          for flops in flopss:
            pylab.plot( getMeasurements(dim,particles,ppc,flops)[0], getMeasurements(dim,particles,ppc,flops)[1],  symbols[symbolAndColourCounter], color=colours[symbolAndColourCounter], markersize=markersizes[symbolAndColourCounter], markevery=1, alpha=AlphaValue )	  
            symbolAndColourCounter = symbolAndColourCounter + 1
          pylab.plot( getMeasurements(dim,particles,ppc,flopss[0])[0], getMeasurements(dim,particles,ppc,flopss[0])[1], symbols[symbolAndColourCounter],  label="#particles=" + "%.1e" % particles, color=colours[symbolAndColourCounter], markersize=markersizes[symbolAndColourCounter], markevery=1, alpha=1.0        )
          symbolAndColourCounter = symbolAndColourCounter + 6*4 - 6 + 1
    
        setGeneralPlotSettings()
    	
        pylab.title( toString(sys.argv[1]) + ", " + str(dim) + "d, ppc=" + str(ppc) + ", with flops" )
        pylab.legend(loc='upper left',framealpha=0.5)
        pylab.savefig( outputFileName + ".png" )
        pylab.savefig( outputFileName + ".pdf" )
        pylab.savefig( outputFileName + ".eps" )
        summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
    
        pylab.legend().set_visible(False)
        pylab.savefig( outputFileName + "-no-legend.png" )
        pylab.savefig( outputFileName + "-no-legend.pdf" )
        pylab.savefig( outputFileName + "-no-legend.eps" )
        summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
          
        ppcCounter = ppcCounter+1


def printParticles():
    for dim in dimensions:
      particlesCounter = 0
      for particles in particless:
        outputFileName = "throughput-" + sys.argv[1] + "-" + str(dim) + "d_" + str(particles) + "-particles"
        print "create " + outputFileName
    
        setSpecificPlotSettings()
    
        symbolAndColourCounter = particlesCounter * 6 * 4 + 6
        for ppc in ppcs[1:]:    
          for flops in flopss:
            pylab.plot( getMeasurements(dim,particles,ppc,flops)[0], getMeasurements(dim,particles,ppc,flops)[1],  symbols[symbolAndColourCounter], color=colours[symbolAndColourCounter], markersize=markersizes[symbolAndColourCounter], markevery=1, alpha=AlphaValue )	  
            symbolAndColourCounter = symbolAndColourCounter + 1
          pylab.plot( getMeasurements(dim,particles,ppc,flopss[0])[0], getMeasurements(dim,particles,ppc,flopss[0])[1], symbols[symbolAndColourCounter],  label="ppc=" + "%.1e" % ppc, color=colours[symbolAndColourCounter], markersize=markersizes[symbolAndColourCounter], markevery=1, alpha=1.0        )	  
          symbolAndColourCounter = symbolAndColourCounter + 1 
    
        setGeneralPlotSettings()
    
        pylab.title( toString(sys.argv[1]) + ", " + str(dim) + "d, #particles=" + "%.1e" % particles )
        pylab.legend(loc='upper left',framealpha=0.5)
        
        pylab.savefig( outputFileName + ".png" )
        pylab.savefig( outputFileName + ".pdf" )
        pylab.savefig( outputFileName + ".eps" )
        summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" )
        
        pylab.legend().set_visible(False)
        pylab.savefig( outputFileName + "-no-legend.png" )
        pylab.savefig( outputFileName + "-no-legend.pdf" )
        pylab.savefig( outputFileName + "-no-legend.eps" )
         
          
        particlesCounter = particlesCounter + 1





if len(sys.argv)!=2 and len(sys.argv)!=3:
  print "arguments: [supermuc|polaris] [no-big-experiments] "
  quit()
  
if len(sys.argv)==3:
  particless = [ 10000000, 100000000 ]
  
  
printAll()      
printPPC100And1000()
printPPC1000And10000()
print0Flops()
printPPCs()
printParticles()
