#
# argument is the prefix such as supermuc
#
#
import sys
import os
import os.path

from helpers import *




MaxRanks   = 640000
dimensions = [ 2, 3 ]
ppcs       = [ 100000, 10000, 1000, 100 ]
flopss     = [ 0, 128, 256, 1024, 4096 ]
 

#MaxRanks    = 128
#dimensions = [ 2 ]
#ppcs       = [ 1000 ]
#flopss     = [ 0 ]
 
variant = "mpi"


if len(sys.argv)!=3:
  print "arguments: [supermuc|polaris] [pit|pidt]"
  quit()

if sys.argv[2]=="pit":
  isPit = True
else:
  isPit = False
  


for d in dimensions:
    for exponent in range(7,10):
      particles = 10
      for j in range(1,exponent):
       particles = particles * 10
      outFilename  = "throughput-" + sys.argv[1] + "_" + variant + "_" + str(d) + "d_" + str(particles) + "_particles.table"
      outFile      = open( outFilename, "w" )
   
      outFile.write( "nodes & cores " )
      for ppc in ppcs:
        for flops in flopss:
          outFile.write( " & " )
          outFile.write( str(ppc)+"("+str(flops)+")" )
  
      outFile.write( " \\\\ \n" )
      
      
      for ranks in range(1,MaxRanks):
        ppc = 100000
        inputFilename = sys.argv[1] + "_" + variant + "_" + str(particles) + "-particles_" + str(ppc) + "-ppc_" + str(ranks) + "-ranks-DDim" + str(d) + "-0-flops-per-particle.out"
  
        if os.path.isfile(inputFilename):
          coresPerNode = 16
          ranksPerNode = 6
          if ranks==1:
            outFile.write( "1 & 1" )
          elif ranks==ranksPerNode:
            outFile.write( "1 & 2" )
          else:
            workingNodes = (ranks-ranksPerNode)/ranksPerNode
            outFile.write( str(workingNodes) )
            outFile.write( " & " )
            outFile.write( str(workingNodes*coresPerNode) )
            
          for ppc in ppcs:
            for flops in flopss:
              inputFilename = sys.argv[1] + "_" + variant + "_" + str(particles) + "-particles_" + str(ppc) + "-ppc_" + str(ranks) + "-ranks-DDim"  + str(d) + "-" + str(flops) + "-flops-per-particle.out"
              print( "-- read file " + inputFilename );
              
              actualParticles = getParticles( inputFilename, isPit );
              if (actualParticles==0):
                actualParticles = particles
              runtime         = getRuntime(    inputFilename, isPit );
              iterations      = getIterations( inputFilename, isPit );
            
              outFile.write( " & " )
              if (runtime>0):
                throughput  = actualParticles * iterations / runtime
                outFile.write( "%4.3g"%throughput )
              else:
                outFile.write( " ?0 " )
  
          outFile.write( " \\\\ \n" )
      #outFile.write( " \n " )
          
    outFile.close()
  