#
# argument is the prefix such as supermuc
#
#
import sys
import os
import pylab

from helpers import *




variants   = [ "pit", "pidt" ]
dimensions = [ 2, 3 ]
dams       = [ 1.0, 0.1 ]  
dts        = [ "0.00001", "0.0001", "0.001", "0.01", "0.1", "1" ]
ppcs       = [ 10000000, 1000000, 100000, 10000, 1000, 100, 10 ]


MaxSamples   = 10
MaxTimeSteps = 50
#AlphaValue   = 0.02
AlphaValue   = 0.1

   

def getMeasurements(ppc,dt,homogeneous,dimensions,variant):
  inputFileName = "lifts-per-particle-workstation_" + str(ppc) + "-ppc_dt-" + dt + ".table"
  result = []
  startColumn   = 1
  if dimensions==3:
    startColumn = startColumn + 1*MaxSamples
  if homogeneous==0.1:
    startColumn = startColumn + 2*MaxSamples
  elif homogeneous!=1.0:
    print "error: homoegeneous has to be 0.1 or 1.0"
  if variant=="pidt":
    startColumn = startColumn + 4*MaxSamples
  for sample in range(0,MaxSamples):
    result.append( readColumnFromTable( inputFileName, sample+startColumn ) )
  result.append( computeAverageColumn(result) )
  return result



summaryHTMLFile = open("summary.html", "w" )


for ppc in ppcs:
  for dim in dimensions:
    for dam in dams:
      for variant in variants:  
	      if dam==0.1:
	        outputFileName = "lifts-per-particle-workstation_" + str(ppc) + "-ppc-0_1-" + str(dim) + "d-" + variant
	      else:
	        outputFileName = "lifts-per-particle-workstation_" + str(ppc) + "-ppc-1_0-" + str(dim) + "d-" + variant
	
	      print "create " + outputFileName
	      
	      pylab.clf()
	      pylab.title( toString(variant) + ", " + str(dim) + "d, $(0.0," + str(dam) + ")^" + str(dim) + "$, ppc=" + str(ppc) )
	      pylab.xlabel('time step')
	      pylab.ylabel('#lifts/particle')
	      
	      xAxis = pylab.arange(0, MaxTimeSteps, 1)
	      for sample in range(0,MaxSamples):
	        #pylab.plot(xAxis, getMeasurements(ppc,"0.00001",dam,dim,variant)[sample],     'o',  color='#000000', alpha=AlphaValue, markersize=10 )
	        #pylab.plot(xAxis, getMeasurements(ppc,"0.0001",dam,dim,variant)[sample],      'v',  color='#00ff00', alpha=AlphaValue, markersize=10 )
	        #pylab.plot(xAxis, getMeasurements(ppc,"0.001",dam,dim,variant)[sample],       '^',  color='#ff0000', alpha=AlphaValue, markersize=10 )
	        pylab.plot(xAxis, getMeasurements(ppc,"0.01",dam,dim,variant)[sample],        's',  color='#cccc00', alpha=AlphaValue, markersize=10 )
	        pylab.plot(xAxis, getMeasurements(ppc,"0.1",dam,dim,variant)[sample],         'd',  color='#00cccc', alpha=AlphaValue, markersize=10 )
	        pylab.plot(xAxis, getMeasurements(ppc,"1",dam,dim,variant)[sample],           '*',  color='#cc00cc', alpha=AlphaValue, markersize=10 )
	    
	      #pylab.plot(xAxis, getMeasurements(ppc,"0.00001",dam,dim,variant)[MaxSamples],   '-o', label="$\Delta t$=$10^{-5}$", color='#000000', markersize=10, markevery=5 )
	      #pylab.plot(xAxis, getMeasurements(ppc,"0.0001",dam,dim,variant)[MaxSamples],    '-v', label="$\Delta t$=$10^{-4}$", color='#00ff00', markersize=10, markevery=7 )
	      #pylab.plot(xAxis, getMeasurements(ppc,"0.001",dam,dim,variant)[MaxSamples],     '-^', label="$\Delta t$=$10^{-3}$", color='#ff0000', markersize=10, markevery=9 )
	      pylab.plot(xAxis, getMeasurements(ppc,"0.01",dam,dim,variant)[MaxSamples],      '-s', label="$\Delta t$=$10^{-2}$", color='#cccc00', markersize=10, markevery=11 )
	      pylab.plot(xAxis, getMeasurements(ppc,"0.1",dam,dim,variant)[MaxSamples],       '-d', label="$\Delta t$=$10^{-1}$", color='#00cccc', markersize=10, markevery=13 )
	      pylab.plot(xAxis, getMeasurements(ppc,"1",dam,dim,variant)[MaxSamples],         '-*', label="$\Delta t$=$10^{-0}$", color='#cc00cc', markersize=10, markevery=17 )
	  
	      setGeneralPlotSettings()
	
	      pylab.savefig( outputFileName + ".png" )
	      pylab.savefig( outputFileName + ".pdf" )
	      pylab.savefig( outputFileName + ".eps" )
	      summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
	      
	      pylab.legend().set_visible(False)
	      pylab.savefig( outputFileName + "-no-legend.png" )
	      pylab.savefig( outputFileName + "-no-legend.pdf" )
	      pylab.savefig( outputFileName + "-no-legend.eps" )
	      summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
      


for dt in dts:
  for dim in dimensions:
    for dam in dams:
      for variant in variants:  
	      if dam==0.1:
	        outputFileName = "lifts-per-particle-workstation_dt-" + dt.replace(".","_") + "-0_1-" + str(dim) + "d-" + variant
	      else:
	        outputFileName = "lifts-per-particle-workstation_dt-" + dt.replace(".","_") + "-1_0-" + str(dim) + "d-" + variant
	
	      print "create " + outputFileName
	      
	      pylab.clf()
	      pylab.title( toString(variant) + ", " + str(dim) + "d, $(0.0," + str(dam) + ")^" + str(dim) + "$, $\Delta t$=" + dt )
	      pylab.xlabel('time step')
	      pylab.ylabel('#lifts/particle')
	      #pylab.yscale('symlog')
	  
	      xAxis = pylab.arange(0, MaxTimeSteps, 1)
	      for sample in range(0,MaxSamples):
	        #pylab.plot(xAxis, getMeasurements(1000000,dt,dam,dim,variant)[sample], 'o',  color='#000000', alpha=AlphaValue, markersize=10 )
	        #pylab.plot(xAxis, getMeasurements(100000,dt,dam,dim,variant)[sample],  'v',  color='#00ff00', alpha=AlphaValue, markersize=10 )
	        pylab.plot(xAxis, getMeasurements(10000,dt,dam,dim,variant)[sample],   '^',  color='#ff0000', alpha=AlphaValue, markersize=10 )
	        pylab.plot(xAxis, getMeasurements(1000,dt,dam,dim,variant)[sample],    's',  color='#cccc00', alpha=AlphaValue, markersize=10 )
	        pylab.plot(xAxis, getMeasurements(100,dt,dam,dim,variant)[sample],     'd',  color='#00cccc', alpha=AlphaValue, markersize=10 )
	        pylab.plot(xAxis, getMeasurements(10,dt,dam,dim,variant)[sample],      '*',  color='#cc00cc', alpha=AlphaValue, markersize=10 )
	    
	      #pylab.plot(xAxis, getMeasurements(1000000,dt,dam,dim,variant)[MaxSamples],   '-o', label="ppc=1000000", color='#000000', markersize=10, markevery=5 )
	      #pylab.plot(xAxis, getMeasurements(100000,dt,dam,dim,variant)[MaxSamples],    '-v', label="ppc=100000", color='#00ff00', markersize=10, markevery=7 )
	      pylab.plot(xAxis, getMeasurements(10000,dt,dam,dim,variant)[MaxSamples],     '-^', label="ppc=10000", color='#ff0000', markersize=10, markevery=9 )
	      pylab.plot(xAxis, getMeasurements(1000,dt,dam,dim,variant)[MaxSamples],      '-s', label="ppc=1000", color='#cccc00', markersize=10, markevery=11 )
	      pylab.plot(xAxis, getMeasurements(100,dt,dam,dim,variant)[MaxSamples],       '-d', label="ppc=100", color='#00cccc', markersize=10, markevery=13 )
	      pylab.plot(xAxis, getMeasurements(10,dt,dam,dim,variant)[MaxSamples],        '-*', label="ppc=10", color='#cc00cc', markersize=10, markevery=17 )
	  
	      setGeneralPlotSettings()
	      
	      if (dam!=0.1 or variant!="pit"):
	        pylab.legend().set_visible(False)
	
	      pylab.savefig( outputFileName + ".png" )
	      pylab.savefig( outputFileName + ".pdf" )
	      pylab.savefig( outputFileName + ".eps" )      
	      summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 
	      
	      
