#
# argument is the prefix such as supermuc
#
#
import sys
import os

from helpers import *




variants   = [ "pit", "pidt" ]
dimensions = [ 2, 3 ]
dams       = [ "1.0", "0.1" ]  
dts        = [ "0.00001", "0.0001", "0.001", "0.01", "0.1", "1" ]
ppcs       = [ 10000000, 1000000, 100000, 10000, 1000, 100, 10 ]


maxLevels  = 6
maxSamples = 10


maxTimeSteps = 50




def getLiftsPerParticles(it,filename):
  try:
    file = open(filename, "r" )
  except:
    print( "was not able to open file " + filename )
    return -1
  try: 
    data = "   "
    while ( not data=="" and it>0):
      data = file.readline()
      if ( re.search( "#lifts per particle", data ) ):
        it = it-1
    while ( not data=="" and not re.search( "#lifts per particle", data )):
      data = file.readline()
    if ( not data=="" ):
      data = data.split("=")[1]
      data = data.split("(")[0]
      data = data.split(",")[0]
      return float(data.strip())
    else:
      return -1
  except:
    print( "was not able to parse file " + filename + " and search for #particles substring")
    return -1
    


for dt in dts: 
  for ppc in ppcs:
    outFilename   = "lifts-per-particle-" + sys.argv[1] + "_" + str(ppc) + "-ppc_dt-" + dt + ".table"
    outFile       = open( outFilename, "w" )

    outFile.write( " timestep " )

    for variant in variants:
      for dam in dams:
        for d in dimensions:
          outFile.write( "  &  " )
          outFile.write( variant + "," + dam + "," + str(d) + "d"  )
          for s in range(maxSamples):
            outFile.write( "  &  " )
    outFile.write( "\n" )

    for t in range(maxTimeSteps):
      outFile.write( str(t) )
 
      for variant in variants:
        for dam in dams:
          for d in dimensions:
            for s in range(maxSamples):
              inputFilename = sys.argv[1] + "_DDim" + str(d) + "_" + variant + "_1e7_" + str(ppc) + "_" + dt + "_" + dam + "_" + str(s) + ".out"
              liftsPerParticle = getLiftsPerParticles(t,inputFilename)
              outFile.write( "  &  " )
              outFile.write( "%4.3g"%liftsPerParticle )
 

      outFile.write( "\n" ) 
    

