#
# argument is the prefix such as supermuc
#
#
import sys
import os

from helpers import *


def getRuntimeFromRunner(filename):
  result = 0
  try:
    file = open(filename, "r" )
    data = "   "
    while ( not data=="" and not re.search( "runMemoryBenchmark", data )):
        data = file.readline()
    if ( not data=="" ):
      result = float(data.split(",")[-1].split("s")[0].strip())
  except:
    print( "was not able to open or read file " + filename )
  finally:
    return result
    



dimensions = [ 2, 3 ]
particles  = [ 1000, 10000, 100000, 1000000, 10000000, 100000000 ]
cores      = [ 1, 2, 4, 8, 12, 16, 32 ]

iterations = 500

for d in dimensions:
  outFilename            = sys.argv[1] + "-" + str(d) + "d.table"
  summaryOutFile         = open( "throughput-" + outFilename, "w" )
  hardwareCounterOutFile = open( "hardware-counter-" + outFilename, "w" )
  print( "- write file " + outFilename );

  hardwareCounterOutFile.write( " data: throughput,flops,l2-volume,l2-hit-rate,l3-volume" );

  summaryOutFile.write(         " \#particles & serial" );
  hardwareCounterOutFile.write( " \#particles & serial" );

  for c in cores:
    summaryOutFile.write(         " &      " + str(c) )
    hardwareCounterOutFile.write( " &      " + str(c) )

  summaryOutFile.write( " \\\\ \n" );
  summaryOutFile.write( " \hline \n " );

  hardwareCounterOutFile.write( " \\\\ \n" );
  hardwareCounterOutFile.write( " \hline \n " );

  for p in particles:
    summaryOutFile.write( "%4.3g"%p )
    summaryOutFile.write( " & " )

    hardwareCounterOutFile.write( "%4.3g"%p )
    hardwareCounterOutFile.write( " & " )
    
    inputFilename = sys.argv[1] + "_" + str(p) + "-particles-DDim" + str(d)
    print( "-- read file " + inputFilename );

    runtime     = getRuntimeFromRunner( inputFilename + "-pure.out" )
    flops       = getLikwidField( inputFilename + "-flops.out", "MFlops/s STAT", 3 )
    l2volume    = getLikwidField( inputFilename + "-l2.out", "data volume \[GBytes\] STAT", 3 )
    cacheMisses = getLikwidField( inputFilename + "-cache.out", "L2 miss ratio STAT", 3 )
    l3volume    = getLikwidField( inputFilename + "-l3.out", "data volume \[GBytes\] STAT", 3 )

    if (runtime>0):
      throughput  = p * iterations / runtime
      summaryOutFile.write( "%4.3g"%throughput )
    else:
      summaryOutFile.write( " ?0 " )
    
    for c in cores:
      inputFilename = sys.argv[1] + "_" + str(p) + "-particles-DDim" + str(d) + "-" + str(c) + "-cores"

      runtime     = getRuntimeFromRunner( inputFilename + "-pure.out" )
      flops       = getLikwidField( inputFilename + "-flops.out", "MFlops/s STAT", 3 )
      l2volume    = getLikwidField( inputFilename + "-l2.out", "data volume \[GBytes\] STAT", 3 )
      cacheMisses = getLikwidField( inputFilename + "-cache.out", "L2 miss ratio STAT", 3 )
      l3volume    = getLikwidField( inputFilename + "-l3.out", "data volume \[GBytes\] STAT", 3 )

      hardwareCounterOutFile.write( " & " )

      if (runtime>0):
        throughput  = p * iterations / runtime

        summaryOutFile.write( " & " )
        summaryOutFile.write( "%4.3g"%throughput )

        hardwareCounterOutFile.write( "%4.3g"%throughput )
        hardwareCounterOutFile.write( "," )
      else:
        summaryOutFile.write( " ?0 & " )
        hardwareCounterOutFile.write( "-," )
       
      
      hardwareCounterOutFile.write( "%4.3g"%flops )
      hardwareCounterOutFile.write( "," )
      hardwareCounterOutFile.write( "%4.3g"%l2volume )
      hardwareCounterOutFile.write( "," )
      hardwareCounterOutFile.write( "%4.3g"%cacheMisses )
      hardwareCounterOutFile.write( "," )
      hardwareCounterOutFile.write( "%4.3g"%l3volume )
  
    summaryOutFile.write( " \\\\ \n " );
    hardwareCounterOutFile.write( " \\\\ \n " );
       
