#
# argument is the prefix such as supermuc
#
#
import sys
import os
import os.path


from helpers import *


NumerOfTimeSteps = 10 
MaxRanks   = 640000
MaxRanks   = 100000
dimensions = [ 2, 3 ]
dts        = [ 0.01, 0.001, 0.0001, 0.00001, 0.000001, 0.0000001 ]
variants   = [ "pit", "pidt", "rapidt" ]  


def convertDtToString(mydt):
  result = "0."
  mydt   = mydt * 10
  while mydt<1:
    mydt   = mydt * 10
    result = result + "0"
  result = result + "1"
  return result




if len(sys.argv)!=2:
  print "usage: script-name [polaris|supermuc]"
  quit()

if sys.argv[1]=="polaris":
  particless = [  10000000,  20000000,  40000000,  100000000,  200000000,  400000000 ]

if sys.argv[1]=="supermuc":
  particless = [ 100000000, 200000000, 400000000, 1000000000, 2000000000, 4000000000 ]

 
for d in dimensions:
  for particles in particless:
    for variant in variants: 
      outFilename  = sys.argv[1] + "_" + variant + "_" + str(particles) + "-particles_" + str(d) + "d.table"
      outFile      = open( outFilename, "w" )
      
      print "write file " + outFilename
        
      outFile.write( "nodes & cores " )
      for dt in dts:
        outFile.write( " & " )
        outFile.write( convertDtToString(dt) )
 
      outFile.write( " \\\\ \n" )

      for ranks in range(1,MaxRanks):
        foundDataForTheseRanks = False
        for dt in dts:
          inFilename   = sys.argv[1] + "_" + variant + "_" + str(particles) + "-particles_dt-" + convertDtToString(dt) + "_" + str(ranks) + "-ranks-DDim" + str(d) + ".out"
          if os.path.isfile(inFilename):
            foundDataForTheseRanks = True
            print "found " + inFilename
          #else:
          #  print "file " + inFilename + " is not in the path"
        if (foundDataForTheseRanks):
          print "found data for " + str(ranks) + " ranks and " + str(particles) + " particles in " + str(d) + " dimensions"
          coresPerNode = 16
          ranksPerNode = 6
          if ranks==1:
            outFile.write( "1 & 1" )
          elif ranks==ranksPerNode:
            outFile.write( "1 & 2" )
          else:
            workingNodes = (ranks-ranksPerNode)/ranksPerNode
            outFile.write( str(workingNodes) )
            outFile.write( " & " )
            outFile.write( str(workingNodes*coresPerNode) )
        
          for dt in dts:
              inFilename   = sys.argv[1] + "_" + variant + "_" + str(particles) + "-particles_dt-" + convertDtToString(dt) + "_" + str(ranks) + "-ranks-DDim" + str(d) + ".out"

              throughput = 0
              if os.path.isfile(inFilename):
                actualParticles = getParticles( inFilename, variant=="pit" );
                if (actualParticles==0):
                  actualParticles = particles
                  print "WARNING: Was not able to read real number of particles and thus switched back to " + str(particles) + " particles"
                runtime         = getRuntime(    inFilename, variant=="pit" );
                iterations      = getIterations( inFilename, variant=="pit" );
                if (iterations!=10):
                  print "WARNING: I recommend to reduce the number of time steps to 10. Got " + str(iterations) + " time steps"
                if (runtime>0 and iterations>0):
                  throughput  = actualParticles * iterations / runtime
                  
                if (throughput<0):
                  print "error for throughput " + "%4.3g"%throughput + " resulting from " + "%4.3g"%actualParticles + ", " + str(iterations) + ", " + "%4.3g"%runtime
                  quit
 
              outFile.write( " & " )
              outFile.write( "%4.3g"%throughput )
              

          outFile.write( "\n" )
          
      outFile.close()
  