#
# argument is the prefix such as supermuc
#
#
import sys
import os
import pylab

from helpers import *




dimensions = [ 2, 3 ]
variants   = [ "pit", "pidt", "rapidt" ]
 


MaxTimeSteps = 10
#AlphaValue   = 0.02
AlphaValue   = 0.2


def getInputFilename(variant,particles,dim):
   return sys.argv[1] + "_" + variant + "_" + str(particles) + "-particles_" + str(dim) + "d.table"



def preparePlot(maxCores):
     pylab.clf()
     pylab.xlabel('cores')
     pylab.ylabel('#particles/s')
     pylab.loglog( basex=2, basey=10 )
     #pylab.yscale( "log" )
     pylab.xlim([16,maxCores])
     
     startOfLinearSpeedupGraph = 1e6
     pylab.ylim([startOfLinearSpeedupGraph,startOfLinearSpeedupGraph*maxCores])
     #pylab.yticks(
     #  [    1e6,      1e7,      1e8,      1e9,      1e10 ],
     #  [ "$10^6$", "$10^7$", "$10^8$", "$10^9$", "$10^{10}$" ]
     #)
     pylab.plot( [16,maxCores], [startOfLinearSpeedupGraph,maxCores*startOfLinearSpeedupGraph], "-", color="#000000" )


Dts        = [ 0.01, 0.001, 0.0001, 0.00001, 0.000001, 0.0000001 ]


Particles = [  
   10000000,   20000000,   40000000,  
  100000000,  200000000,  400000000, 
 1000000000, 2000000000, 4000000000 
]


Markers = [
  "-D", "--D", "-D", "--D", "-D", "--D", "-D", "--D", "-D",    # 1e8; different dt 
  "-<", "--<", "-<", "--<", "-<", "--<", "-<", "--<", "-<",  
  "-v", "--v", "-v", "--v", "-v", "--v", "-v", "--v", "-v",  

  "->", "-->", "->", "-->", "->", "-->", "->", "-->", "->",  
  "-^", "--^", "-^", "--^", "-^", "--^", "-^", "--^", "-^",  
  "-s", "--s", "-s", "--s", "-s", "--s", "-s", "--s", "-s",  
  
  "-o", "--o", "-o", "--o", "-o", "--o", "-o", "--o", "-o",  
  "-*", "--*", "-*", "--*", "-*", "--*", "-*", "--*", "-*",  
  "-d", "--d", "-d", "--d", "-d", "--d", "-d", "--d", "-d",  
]


Colours = [
  "#0000ff", "#00ff00", "#ff0000", "#00aaff", "#aa00ff", "#00ffaa", "#aaff00", "#ffaa00", "#ff00aa",  
  "#0000ff", "#00ff00", "#ff0000", "#00aaff", "#aa00ff", "#00ffaa", "#aaff00", "#ffaa00", "#ff00aa",  
  "#0000ff", "#00ff00", "#ff0000", "#00aaff", "#aa00ff", "#00ffaa", "#aaff00", "#ffaa00", "#ff00aa",  

  "#0000ff", "#00ff00", "#ff0000", "#00aaff", "#aa00ff", "#00ffaa", "#aaff00", "#ffaa00", "#ff00aa",  
  "#0000ff", "#00ff00", "#ff0000", "#00aaff", "#aa00ff", "#00ffaa", "#aaff00", "#ffaa00", "#ff00aa",  
  "#0000ff", "#00ff00", "#ff0000", "#00aaff", "#aa00ff", "#00ffaa", "#aaff00", "#ffaa00", "#ff00aa",  

  "#0000ff", "#00ff00", "#ff0000", "#00aaff", "#aa00ff", "#00ffaa", "#aaff00", "#ffaa00", "#ff00aa",  
  "#0000ff", "#00ff00", "#ff0000", "#00aaff", "#aa00ff", "#00ffaa", "#aaff00", "#ffaa00", "#ff00aa",  
  "#0000ff", "#00ff00", "#ff0000", "#00aaff", "#aa00ff", "#00ffaa", "#aaff00", "#ffaa00", "#ff00aa",  
]



def plotSpeedups(dim,variant):
  for legendVariant in range(0,len(Particles)+1):
     outputFileName = "speedup-" + sys.argv[1] + "-" + str(variant) + "-"+ str(dim) + "d-legend-" + str(legendVariant)
     print "create " + outputFileName
     if sys.argv[1]=="polaris":
       preparePlot(4096)
       pylab.xticks(
         [  16,   64,   256,   1024,   4096  ], 
         [ "16", "64", "256", "1024", "4096" ]
       )
     else:
       preparePlot(16384)
       pylab.xticks(
         [  32,   128,   512,   2048,   9102  ], 
         [ "32", "128", "512", "2048", "9102" ]
       )
       #pylab.xticks(
       #  [  16,   128,   512,   2048,   9102,   32768  ], 
       #  [ "16", "128", "512", "2048", "9102", "32768" ]
       #)
     
 
     for pParticles in range(0,len(Particles)):
       particles     = Particles[pParticles]
       ColumnCounter = 2
       for pDt in range(0,len(Dts)):
         MarkerCounter = pParticles*len(Particles) + pDt
         dt             = Dts[pDt]
         inputFileName  = getInputFilename(variant,particles,dim)
         cores          = readColumnFromTable(inputFileName,1)
         throughput     = readColumnFromTable(inputFileName,ColumnCounter)
        
         (cores,throughput) = compactData(cores,throughput)
       
         AlphaValue = 0.65
         
         if len(cores)>0:
           #pylab.plot( cores, throughput, Markers[MarkerCounter],  label = "MarkerCounter=" + str(MarkerCounter), color=Colours[MarkerCounter], markersize=14, markevery=1 )
           if pParticles==legendVariant:
             pylab.plot( cores, throughput, Markers[MarkerCounter],  label =  "%0.1e"%particles + ", $\Delta t$=" + "%0.1e"%dt , color=Colours[MarkerCounter], markersize=14, markevery=1, alpha=AlphaValue )
             #pylab.plot( cores, throughput, Markers[MarkerCounter],  label = "pParticles=" + str(pParticles) + ", mc=" + str(MarkerCounter) , color=Colours[MarkerCounter], markersize=14, markevery=1 )
           else: 
             pylab.plot( cores, throughput, Markers[MarkerCounter],  color=Colours[MarkerCounter], markersize=14, markevery=1, alpha=AlphaValue )
         ColumnCounter  = ColumnCounter + 1
            
     setGeneralPlotSettings()

     pylab.title( toString(sys.argv[1]) + ", " + toString(variant) + "," + str(dim) + "d" )

     pylab.legend(loc='upper left',framealpha=0.5)
     pylab.savefig( outputFileName + "-left-top.png" )
     pylab.savefig( outputFileName + "-left-top.pdf" )
     summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 

     pylab.legend(loc='lower right',framealpha=0.5)
     pylab.savefig( outputFileName + "-right-bottom.png" )
     pylab.savefig( outputFileName + "-right-bottom.pdf" )
     summaryHTMLFile.write( "<img src=\"" +  outputFileName + ".png\" /> <br />" ) 




def createPlots():
  for dim in dimensions:
     for variant in variants:
       plotSpeedups(dim,variant)


if len(sys.argv)!=2:
  print "usage: script-name [polaris|supermuc]"
  quit()

summaryHTMLFile = open("summary-" + sys.argv[1] + ".html", "w" )

createPlots()      
