rm -f *.err
rm -rf temp-scripts

mkdir temp-scripts


#
# 512 is magic island size
# 3264 ranks, i.e. 544 nodes is already too big for class general
#


for d in DDim2 DDim3
do
  #
  # 10^8 particles
  #
  particles=100000000
  dt=0.001
  templateFile="GeneralClassSuperMUC0.llscript"
  for nodes in 2 6 12 24
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done
  templateFile="GeneralClassSuperMUC1.llscript"
  for nodes in 48 96 160 224 288 352
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done

  dt=0.0001
  for nodes in 12 24 48 96 160 224 288 352 416 480   
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done
  
  #
  # 10^9 particles
  #
  particles=1000000000


  dt=0.0001
  templateFile="GeneralClassSuperMUC0.llscript"
  for nodes in 6 12 24
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done
  templateFile="GeneralClassSuperMUC1.llscript"
  for nodes in 48 96 160 224 288 352
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done

  dt=0.00001
  for nodes in 12 24 48 96 160 224 288 352 416 480   
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done

  dt=0.000001
  for nodes in 48 96 160 224 288 352 416 
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done
  templateFile="GeneralClassSuperMUC2.llscript"
  for nodes in 544 608 672
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done

  #
  # 2 * 10^9 particles
  #
  particles=2000000000

  dt=0.0001
  templateFile="GeneralClassSuperMUC1.llscript"
  for nodes in 48 96 160 224 288 352 416 480
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done

  dt=0.00001
  templateFile="GeneralClassSuperMUC1.llscript"
  for nodes in 96 160 224 288 352 416 480   
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done
  templateFile="GeneralClassSuperMUC2.llscript"
  for nodes in 544 608 
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done

  dt=0.000001
  templateFile="GeneralClassSuperMUC1.llscript"
  for nodes in 224 288 352 416 480
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done
  templateFile="GeneralClassSuperMUC2.llscript"
  for nodes in 544 608 672 736
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done
  
  
  #
  # 4 * 10^9 particles
  #
  particles=4000000000

  dt=0.00001
  templateFile="GeneralClassSuperMUC1.llscript"
  for nodes in 160 224 288 352 416 480
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done

  dt=0.000001
  templateFile="GeneralClassSuperMUC1.llscript"
  for nodes in 96 160 224 288 352 416 480   
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done
  templateFile="GeneralClassSuperMUC3.llscript"
  for nodes in 544 608 672 736
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done

  dt=0.0000001
  templateFile="GeneralClassSuperMUC3.llscript"
  for nodes in 544 672 800 928 1056 1184
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done
  
  
  
  #
  # 8 * 10^9 particles
  #
  particles=8000000000

  dt=0.00001
  templateFile="GeneralClassSuperMUC1.llscript"
  for nodes in 352 480
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done
  templateFile="GeneralClassSuperMUC3.llscript"
  for nodes in 544 672 736 800
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done

  dt=0.000001
  templateFile="GeneralClassSuperMUC3.llscript"
  for nodes in 544 672 736 800 928 1056
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done

  dt=0.0000001
  templateFile="GeneralClassSuperMUC3.llscript"
  for nodes in 800 928 1056 1184 1312 1440
  do
    ./create-one-run-SuperMUC.sh $templateFile $d $particles $dt $nodes
  done
done

