rm -f *.err
rm -rf temp-scripts

mkdir temp-scripts
mkdir /nobackup/durtw/mpi-pidt/


particles=10000000
ranks=1
nodes=1
templateFile="MicroClass.csh"
scriptFile="temp-scripts/MPI_"$particles"_"$ranks".csh"
sed "s/RANKS/$ranks/g" $templateFile > temp-scripts/tmp1.csh
sed "s/PARTICLES/$particles/g" temp-scripts/tmp1.csh > temp-scripts/tmp2.csh
sed "s/NODES/$nodes/g" temp-scripts/tmp2.csh > $scriptFile
echo Submit $scriptFile
qsub $scriptFile



#
# Seems to me that 1,2 and 4 do not pass in micro class.
#
particles=10000000
for nodes in 1 2 4 6 8 10 12 14 16 20 24 
do
  ranks=$((nodes*6))
  templateFile="MicroClass.csh"
  scriptFile="temp-scripts/MPI_"$particles"_"$ranks".csh"
  sed "s/RANKS/$ranks/g" $templateFile > temp-scripts/tmp1.csh
  sed "s/PARTICLES/$particles/g" temp-scripts/tmp1.csh > temp-scripts/tmp2.csh
  sed "s/NODES/$nodes/g" temp-scripts/tmp2.csh > $scriptFile
  echo Submit $scriptFile
  qsub $scriptFile
done



#
# Up to 16, all runs exceed runtime, i.e. have to be submitted in the general class
#
particles=100000000
for nodes in 1 2 4 6 8 10 12 14 16 20 24 
do
  ranks=$((nodes*6))
  templateFile="MicroClass.csh"
  scriptFile="temp-scripts/MPI_"$particles"_"$ranks".csh"
  sed "s/RANKS/$ranks/g" $templateFile > temp-scripts/tmp1.csh
  sed "s/PARTICLES/$particles/g" temp-scripts/tmp1.csh > temp-scripts/tmp2.csh
  sed "s/NODES/$nodes/g" temp-scripts/tmp2.csh > $scriptFile
  echo Submit $scriptFile
  qsub $scriptFile
done
for nodes in 32 40 48 56 64 72 80 88 96 104 112 120 128
do
  ranks=$((nodes*6))
  templateFile="GeneralClass0.csh"
  scriptFile="temp-scripts/MPI_"$particles"_"$ranks".csh"
  sed "s/RANKS/$ranks/g" $templateFile > temp-scripts/tmp1.csh
  sed "s/PARTICLES/$particles/g" temp-scripts/tmp1.csh > temp-scripts/tmp2.csh
  sed "s/NODES/$nodes/g" temp-scripts/tmp2.csh > $scriptFile
  echo Submit $scriptFile
  qsub $scriptFile
done




particles=1000000000
for nodes in 64 80 96 112 128 
do
  ranks=$((nodes*6))
  templateFile="GeneralClass1.csh"
  scriptFile="temp-scripts/MPI_"$particles"_"$ranks".csh"
  sed "s/RANKS/$ranks/g" $templateFile > temp-scripts/tmp1.csh
  sed "s/PARTICLES/$particles/g" temp-scripts/tmp1.csh > temp-scripts/tmp2.csh
  sed "s/NODES/$nodes/g" temp-scripts/tmp2.csh > $scriptFile
  echo Submit $scriptFile
  qsub $scriptFile
done

qstat
