rm -f *.err
rm -rf temp-scripts

mkdir temp-scripts


particles=10000000
ranks=1
nodes=1
templateFile="MicroClass.llscript"
scriptFile="temp-scripts/MPI_"$particles"_"$ranks".llscript"
sed "s/RANKS/$ranks/g" $templateFile > temp-scripts/tmp1.llscript
sed "s/PARTICLES/$particles/g" temp-scripts/tmp1.llscript > temp-scripts/tmp2.llscript
sed "s/NODES/$nodes/g" temp-scripts/tmp2.llscript > $scriptFile
echo Submit $scriptFile
llsubmit $scriptFile



#
# Seems to me that 1,2 and 4 do not pass in micro class.
#
particles=10000000
for nodes in 1 2 4 6 8 10 12 14 16 20 24 28 32 
do
  ranks=$((nodes*6))
  templateFile="MicroClass.llscript"
  scriptFile="temp-scripts/MPI_"$particles"_"$ranks".llscript"
  sed "s/RANKS/$ranks/g" $templateFile > temp-scripts/tmp1.llscript
  sed "s/PARTICLES/$particles/g" temp-scripts/tmp1.llscript > temp-scripts/tmp2.llscript
  sed "s/NODES/$nodes/g" temp-scripts/tmp2.llscript > $scriptFile
  echo Submit $scriptFile
  llsubmit $scriptFile
done



#
# Up to 16, all runs exceed runtime, i.e. have to be submitted in the general class
#
particles=100000000
for nodes in 1 2 4 6 8 10 12 14 16 20 24 28 
do
  ranks=$((nodes*6))
  templateFile="MicroClass.llscript"
  scriptFile="temp-scripts/MPI_"$particles"_"$ranks".llscript"
  sed "s/RANKS/$ranks/g" $templateFile > temp-scripts/tmp1.llscript
  sed "s/PARTICLES/$particles/g" temp-scripts/tmp1.llscript > temp-scripts/tmp2.llscript
  sed "s/NODES/$nodes/g" temp-scripts/tmp2.llscript > $scriptFile
  echo Submit $scriptFile
  llsubmit $scriptFile
done
for nodes in 32 40 48 56 64 72 80 88 96 104 112 120 128
do
  ranks=$((nodes*6))
  templateFile="GeneralClass0.llscript"
  scriptFile="temp-scripts/MPI_"$particles"_"$ranks".llscript"
  sed "s/RANKS/$ranks/g" $templateFile > temp-scripts/tmp1.llscript
  sed "s/PARTICLES/$particles/g" temp-scripts/tmp1.llscript > temp-scripts/tmp2.llscript
  sed "s/NODES/$nodes/g" temp-scripts/tmp2.llscript > $scriptFile
  echo Submit $scriptFile
  llsubmit $scriptFile
done




particles=1000000000
for nodes in 8 10 12 24 
do
  ranks=$((nodes*6))
  templateFile="MicroClass.llscript"
  scriptFile="temp-scripts/MPI_"$particles"_"$ranks".llscript"
  sed "s/RANKS/$ranks/g" $templateFile > temp-scripts/tmp1.llscript
  sed "s/PARTICLES/$particles/g" temp-scripts/tmp1.llscript > temp-scripts/tmp2.llscript
  sed "s/NODES/$nodes/g" temp-scripts/tmp2.llscript > $scriptFile
  echo Submit $scriptFile
  llsubmit $scriptFile
done
for nodes in 36 48 64 80 96 112 128 
do
  ranks=$((nodes*6))
  templateFile="GeneralClass1.llscript"
  scriptFile="temp-scripts/MPI_"$particles"_"$ranks".llscript"
  sed "s/RANKS/$ranks/g" $templateFile > temp-scripts/tmp1.llscript
  sed "s/PARTICLES/$particles/g" temp-scripts/tmp1.llscript > temp-scripts/tmp2.llscript
  sed "s/NODES/$nodes/g" temp-scripts/tmp2.llscript > $scriptFile
  echo Submit $scriptFile
  llsubmit $scriptFile
done


llq -u $USER
