#
# argument is the prefix such as supermuc
#
#
import sys
import os

from helpers import *




variants   = [ "pit", "pidt" ]
dimensions = [ 2, 3 ]
dams       = [ 1.0, 0.1 ]  
dts        = [ "000001", "0001", "01" ]
ppcs       = [ 10000000, 1000000, 100000, 10000, 1000, 100, 10 ]


if len(sys.argv)!=2:
  print "please specify computer name (polaris or supermuc) as argument"
  quit()


for dt in dts:
  outFilename  = "single-core-throughput-dt-0." + str(dt) + "-" + sys.argv[1] + ".table"
  outFile      = open( outFilename, "w" )
  print( "- write file " + outFilename );
  
  outFile.write( "ppc" )
  for variant in variants:
    for d in dimensions:
      for dam in dams:
        outFile.write( " & " )
        outFile.write( variant + ", " + str(dam) )
        outFile.write( " & " )
        outFile.write( "\\#particles" )
  outFile.write( "\\\\  \n " )
  
  for d in dimensions:
    outFile.write( "\hline \n " )
    for ppc in ppcs:
      outFile.write( "%4.1g"%ppc )
      for variant in variants:
        for dam in dams:
          inputFilename = sys.argv[1] + "_" + variant + "-" + str(ppc) + "-ppc-dt-0." + str(dt) + "-dam-" + str(dam) + "-DDim" + str(d)
          print( "-- read file " + inputFilename );
  
          particles   = getParticles(  inputFilename + "-pure.out", variant=="pit" );
          runtime     = getRuntime(    inputFilename + "-pure.out", variant=="pit" );
          iterations  = getIterations( inputFilename + "-pure.out", variant=="pit" );
          
          outFile.write( " & " )
          if (runtime>0):
            throughput  = particles * iterations / runtime
            outFile.write( "%4.3g"%throughput )
          else:
            outFile.write( " ?0 " )
          outFile.write( " & " )
          outFile.write( "%4.1g"%particles )
    
      outFile.write( " \\\\ \n " )

  outFile.close()